Let (API documentation of hlt.language packages)
Date: 2013-01-30

hlt.language.design.kernel

## Class Let

- java.lang.Object
- - hlt.language.design.kernel.Expression
  - - hlt.language.design.kernel.ProtoExpression
    - - hlt.language.design.kernel.Application
      - - hlt.language.design.kernel.Let

- All Implemented Interfaces:
    Locatable

      public class Let
      extends Application

- - ### Field Summary

    - ### Fields inherited from class hlt.language.design.kernel.Expression

      `VOID_ASSIGNMENTS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Let(java.util.AbstractList parameters, java.util.AbstractList types, java.util.AbstractList values, Expression body)`
    `Let(java.util.AbstractList parameters, java.util.AbstractList values, Expression body)`
    `Let(Parameter[] parameters, Expression[] values, Expression body)`
    `Let(Parameter parameter, Expression value, Expression body)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `toString()`
    `void` | `typeCheck(TypeChecker typeChecker)` This method type-checks this expression in the context of the specified `TypeChecker`.

    - ### Methods inherited from class hlt.language.design.kernel.Application

      `argument, arguments, arity, compile, copy, flatten, function, isFieldApplication, isHiddenSlicing, isSelector, isSlicing, isTupleProjection, isUnaryTupleProjection, noCurrying, numberOfSubexpressions, setArguments, setCheckedType, setCheckedType, setFunction, setNoCurrying, setNoCurrying, setSubexpression, slicesParameter, subexpression, typeCheck, typedCopy, undoDummyLocal`

    - ### Methods inherited from class hlt.language.design.kernel.ProtoExpression

      `checkedType, setType, type, typeRef`

    - ### Methods inherited from class hlt.language.design.kernel.Expression

      `addType, addTypes, boxSort, containsFreeName, enclosingScope, extent, getEnd, getStart, isConstant, isEquality, isFalse, isNull, isTrue, isVoid, locationString, otherTypes, parameters, sanitizeNames, sanitizeSorts, setCheckedTypeLocked, setEnd, setExtent, setOtherTypes, setStart, shiftOffsets, shiftOffsets, sort, substitute, typeCheck, typeCheckLocked`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Let

          public Let(Parameter parameter,
             Expression value,
             Expression body)

    - #### Let

          public Let(java.util.AbstractList parameters,
             java.util.AbstractList values,
             Expression body)

    - #### Let

          public Let(Parameter[] parameters,
             Expression[] values,
             Expression body)

    - #### Let

          public Let(java.util.AbstractList parameters,
             java.util.AbstractList types,
             java.util.AbstractList values,
             Expression body)

  - ### Method Detail

    - #### typeCheck

          public void typeCheck(TypeChecker typeChecker)
                         throws TypingErrorException

      Description copied from class: `Expression`
      This method type-checks this expression in the context of the specified `TypeChecker`.
      Overrides:
        `typeCheck` in class `Application`
      Throws:
        `TypingErrorException`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `Application`